#ifndef _cstack_h
#define _cstack_h

struct StackNode {
    StackNode() : _data(' '), _next(0) {}
    StackNode(char c) : _data(c), _next(0) {}
    StackNode(char c, StackNode* n) : _data(c), _next(n) {}
    
    char _data;
    StackNode *_next;
};

class CharStack {
public:
    CharStack() : _size(0), _head(0)
        {}
    ~CharStack() {
        
    }
    
    void push(char c);
    char pop();
    int size() const;
    bool empty();
private:
    int _size;
    StackNode *_head;
};

#endif /* _cstack_h */
